<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
	<title>OIDF Conformance: Conformance Suite</title>

	<!-- Latest compiled and minified CSS -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">

	<!-- Optional theme -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css" integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">
	<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=PT+Sans">
	<link rel="stylesheet" type="text/css" href="css/layout.css">
	<link rel="stylesheet" href="https://gitcdn.github.io/bootstrap-toggle/2.2.2/css/bootstrap-toggle.min.css">

	<!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
	<!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
	<!--[if lt IE 9]>
		<script src="https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js"></script>
		<script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->

    <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>
    <!-- Latest compiled and minified JavaScript -->
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>

	<script src="https://cdnjs.cloudflare.com/ajax/libs/lodash.js/4.17.11/lodash.js" integrity="sha256-vS9J2VYhvwAfh2znnLdkhemFPEpx6YoZEhExqBPT5ys=" crossorigin="anonymous"></script>

    <script src="https://gitcdn.github.io/bootstrap-toggle/2.2.2/js/bootstrap-toggle.min.js"></script>

    <script type="text/javascript" src="js/fapi.ui.js"></script>

</head>
<body>

	<div class="pageHeader container-fluid">
		<div class="row-fluid">
			<div class="col-md-8">
				<a href="index.html"><img src="/images/openid.png"></a>
			</div>
			<div id="userInfoHolder" class="col-md-4 text-right"></div>
		</div>
	</div>
	<div class="clearfix"></div>

	<!-- error modal -->
	<div class="modal fade" id="errorModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
					<h4 class="modal-title" id="errorLabel">Error</h4>
				</div>
				<div class="modal-body">
					Error: <span id="errorMessage"></span>
				</div>
				<div class="modal-footer">
					<button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
				</div>
			</div>
		</div>
	</div>

	<!-- loading modal -->
	<div class="modal fade" id="loadingModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel" data-backdrop="static" data-keyboard="false">
		<div class="modal-dialog modal-sm" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<h4 class="modal-title" id="loadingLabel">Loading...</h4>
				</div>
				<div class="modal-body">
					<div class="text-center">
						<img src="/images/spinner.gif" width="100px" height="30px" />
					</div>
					<div>
						<span id="loadingMessage"></span>
					</div>
				</div>
			</div>
		</div>
	</div>


	<div class="container-fluid">
		<div id="homePage">

			<!-- render available test launch options here -->
            <div class="row">
                <div class="col-md-1">
                    <!-- toggle selector for launch type, multi test by default -->
                    <input data-toggle="toggle"
                        data-on="Single Test" data-off="Multi Test Plan"
                        data-onstyle="info" data-offstyle="primary"
                        data-style="btn-block"
                        data-width="auto" data-height="auto"
                        type="checkbox" id="singleTestSelector">
                </div>
                <div class="col-md-9" id="testSelector">
                    <select id="testSelect" class="form-control">
                        <option value="select">--- Select A Test ----</option>
                    </select>
                </div>
                <div class="col-md-9 collapse" id="planSelector">
                    <select id="planSelect" class="form-control">
                        <option value="select">--- Select A Test Plan ----</option>
                    </select>
                </div>
				<div class="col-md-2">
					<select class="form-control" id="variantSelector" ></select>
				</div>
            </div>

			<div class="row">
				<div class="col-md-12">

					<h3>Configure Test</h3>
					<p>Please see <a href="https://openid.net/certification/instructions/">OpenID Foundation Certification Instructions</a>.</p>

					<ul class="nav nav-tabs">
						<li class="active"><a data-toggle="tab" id="tab-form-elements" href="#formInput">Form</a></li>
						<li><a data-toggle="tab" id="tab-json-elements" href="#JSONInput">JSON</a></li>
					</ul>


					<div class="tab-content">
						<div id="formInput" class="tab-pane fade in active">

							<div class="config-form-container">

								<h3 class="config-form-container-header">Test Information</h3>

								<div class="row config-form-element-container">
									<div class="col-md-2 key">alias</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="alias" placeholder="alias for test instance, used to create consistent URIs across test instances"></input>
									</div>
								</div>

								<div class="row config-form-element-container">
									<div class="col-md-2 key">description</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="description" placeholder="Freeform text to help you identify this test run (optional)"></input>
									</div>
								</div>

								<div class="row config-form-element-container">
									<div class="col-md-2 key">publish</div>
									<div class="col-md-10">
										<select class="config-form-element" data-json-target="publish">
											<option value="" selected>No</option>
											<option value="summary">Summary</option>
											<option value="everything">Everything</option>
										</select>
									</div>
								</div>

							</div>

							<div class="config-form-container">
								<h3 class="config-form-container-header">Server</h3>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">discoveryUrl</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="server.discoveryUrl" placeholder="Full URL to server's .well-known/openid-configuration"></input>
									</div>
								</div>

                                <div class="row config-form-element-container">
                                    <div class="col-md-2 key">discoveryIssuer</div>
                                    <div class="col-md-10">
                                        <input type="text" class="config-form-element" data-json-target="server.discoveryIssuer" placeholder="Server's issuer URL"></input>
                                    </div>
                                </div>

								<div class="row config-form-element-container">
									<div class="col-md-2 key"></div>
									<div class="col-md-10">
										<textarea class="config-form-element" data-json-target="server.jwks" placeholder="Server's keys in JSON Web Key Set (only for RP tests)"></textarea>
									</div>
								</div>
							</div>


							<div class="config-form-container">
								<h3 class="config-form-container-header">Client</h3>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">client_id</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="client.client_id" placeholder="oauth client id used with the authorisation server"></input>
									</div>
								</div>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">client_secret</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="client.client_secret" placeholder="client secret, if applicable"></input>
									</div>
								</div>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">client_name</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="client.client_name" placeholder="client name"></input>
									</div>
								</div>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">scope</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="client.scope" placeholder="scopes to use in authorization request, e.g. openid accounts"></input>
									</div>
								</div>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">redirect_uri</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="client.redirect_uri" placeholder="Only required for RP tests"></input>
									</div>
								</div>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">jwks</div>
									<div class="col-md-10">
										<textarea class="config-form-element" data-json-target="client.jwks" placeholder="Client's private signing key in JSON Web Key Set format, must begin with { &quot;keys&quot;: [ {,  must include 'alg'"></textarea>
									</div>
								</div>
                                <div class="row config-form-element-container">
                                    <div class="col-md-2 key">client_secret_jwt_alg</div>
                                    <div class="col-md-10">
                                        <input type="text" class="config-form-element" data-json-target="client.client_secret_jwt_alg" placeholder="algorithm for client_secret_jwt authentication, defaults to HS256"></input>
                                    </div>
                                </div>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">certificate</div>
									<div class="col-md-10">
										<textarea class="config-form-element" data-json-target="client.certificate" placeholder="TLS client certificate in base64-encoded DER (in JSON string, no headers) or OpenSSL/PEM format - often has .pem file extension"></textarea>
									</div>
								</div>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">hint_type</div>
									<div class="col-md-10">
										<select class="config-form-element" data-json-target="client.hint_type">
											<option value="" selected>None</option>
											<option value="login_hint_token">login_hint_token</option>
											<option value="id_token_hint">id_token_hint</option>
											<option value="login_hint">login_hint</option>
										</select>
									</div>
								</div>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">hint_value</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="client.hint_value" placeholder="hint value to identify user, passed with hint_type in authorisation request"></input>
									</div>
								</div>
							</div>

							<div class="config-form-container">
								<h3 class="config-form-container-header">TLS certificates for client (used to make MTLS connections)</h3>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">mtls.cert</div>
									<div class="col-md-10">
										<textarea class="config-form-element" data-json-target="mtls.cert" placeholder="TLS client certificate in base64-encoded DER (in JSON string, no headers) or OpenSSL/PEM format - often has .pem file extension"></textarea>
									</div>
								</div>

								<div class="row config-form-element-container">
									<div class="col-md-2 key">mtls.key</div>
									<div class="col-md-10">
										<textarea class="config-form-element" data-json-target="mtls.key" placeholder="Unencrypted TLS client key in base64-encoded DER or PEM format (in JSON string no headers) or OpenSSL/PEM format"></textarea>
									</div>
								</div>

								<div class="row config-form-element-container">
									<div class="col-md-2 key">mtls.ca</div>
									<div class="col-md-10">
										<textarea class="config-form-element" data-json-target="mtls.ca" placeholder="TLS client CA in base64-encoded DER (in JSON string, no headers) or OpenSSL/PEM format"></textarea>
									</div>
								</div>
							</div>

							<div class="config-form-container">
								<h3 class="config-form-container-header">Second client</h3>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">client_id</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="client2.client_id" placeholder="oauth client id used with the authorisation server"></input>
									</div>
								</div>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">client_secret</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="client2.client_secret" placeholder="client secret, if applicable"></input>
									</div>
								</div>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">scope</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="client2.scope" placeholder="scopes to use in authorization request, e.g. openid accounts"></input>
									</div>
								</div>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">jwks</div>
									<div class="col-md-10">
										<textarea class="config-form-element" data-json-target="client2.jwks" placeholder="Client's private signing key in JSON Web Key Set format, must begin with { &quot;keys&quot;: [ {,  must include 'alg'"></textarea>
									</div>
								</div>
                                <div class="row config-form-element-container">
                                    <div class="col-md-2 key">client_secret_jwt_alg</div>
                                    <div class="col-md-10">
                                        <input type="text" class="config-form-element" data-json-target="client2.client_secret_jwt_alg" placeholder="algorithm for client_secret_jwt authentication, defaults to HS256"></input>
                                    </div>
                                </div>
							</div>

							<div class="config-form-container">
								<h3 class="config-form-container-header">Second client TLS certificates</h3>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">mtls2.cert</div>
									<div class="col-md-10">
										<textarea class="config-form-element" data-json-target="mtls2.cert" placeholder="TLS client certificate in base64-encoded DER (in JSON string, no headers) or OpenSSL/PEM format"></textarea>
									</div>
								</div>

								<div class="row config-form-element-container">
									<div class="col-md-2 key">mtls2.key</div>
									<div class="col-md-10">
										<textarea class="config-form-element" data-json-target="mtls2.key" placeholder="Unencrypted TLS client key in base64-encoded DER or PEM format (in JSON string no headers) or OpenSSL/PEM format"></textarea>
									</div>
								</div>

								<div class="row config-form-element-container">
									<div class="col-md-2 key">mtls2.ca</div>
									<div class="col-md-10">
										<textarea class="config-form-element" data-json-target="mtls2.ca" placeholder="TLS client CA in base64-encoded DER (in JSON string, no headers) or OpenSSL/PEM format"></textarea>
									</div>
								</div>
							</div>

							<div class="config-form-container">
								<h3 class="config-form-container-header">TLS</h3>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">testHost</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="tls.testHost" placeholder="Hostname for TLS connection tests (only used in sample-test-test)"></input>
									</div>
								</div>

								<div class="row config-form-element-container">
									<div class="col-md-2 key">testPort</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="tls.testPort" placeholder="Port number for TLS connection tests (only used in sample-test-test)"></input>
									</div>
								</div>
							</div>

							<div class="config-form-container">
								<h3 class="config-form-container-header">Resource</h3>
								<div class="row config-form-element-container">
									<div class="col-md-2 key">resourceUrl</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="resource.resourceUrl" placeholder="Base URL to use in resource server tests. For UK OpenBanking tests, this should end in /open-banking/vX.Y/aisp"></input>
									</div>
								</div>

								<div class="row config-form-element-container">
									<div class="col-md-2 key">resourceUrlAccountRequests</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="resource.resourceUrlAccountRequests" placeholder="Base URL to use in resource account request server tests (optional, use if endpoints split across servers)"></input>
									</div>
								</div>

								<div class="row config-form-element-container">
									<div class="col-md-2 key">resourceUrlAccountsResource</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="resource.resourceUrlAccountsResource" placeholder="Base URL to use in resource accounts server tests (optional, use if endpoints split across servers)"></input>
									</div>
								</div>



								<div class="row config-form-element-container">
									<div class="col-md-2 key">institution_id</div>
									<div class="col-md-10">
										<input type="text" class="config-form-element" data-json-target="resource.institution_id" placeholder="Financial institution ID to send to FAPI resources, e.g. Institution ID assigned by UK OpenBanking"></input>
									</div>
								</div>
							</div>


						</div>
						<div id="JSONInput" class="tab-pane fade">
							<textarea id="config" placeholder="{JSON data}"></textarea>
						</div>
					</div>
					<!-- / .tab-content -->
				</div>
			</div>

			<div class="row top10">
				<div class="well col-md-6 col-md-offset-3">
				    <button class="btn btn-block collapse">Fake Button for spacing, ignore</button>
					<button class="btn btn-primary btn-block btn-lg" id="createTestBtn" disabled="">
						<span class="glyphicon glyphicon-flag"></span> Launch Test
					</button>
                    <button class="btn btn-primary btn-block btn-lg collapse" id="createPlanBtn" disabled="">
                        <span class="glyphicon glyphicon-flag"></span> Start Test Plan
                    </button>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<h3>Running tests</h3>
				</div>
			</div>
			<div class="row">
				<div class="col-md-2">
					<button class="btn btn-default btn-block" id="refresh">
						<span class="glyphicon glyphicon-refresh"></span> Refresh
					</button>
                    <a href="logs.html" class="btn btn-info btn-block"><span class="glyphicon glyphicon-duplicate"></span> View all available logs</a>
                    <a href="logs.html?public=true" class="btn btn-info btn-block"><span class="glyphicon glyphicon-duplicate"></span> View published logs</a>
                    <a href="plans.html" class="btn btn-info btn-block"><span class="glyphicon glyphicon-book"></span> View all available plans</a>
                    <a href="plans.html?public=true" class="btn btn-info btn-block"><span class="glyphicon glyphicon-book"></span> View published plans</a>
				</div>

				<div class="col-md-10" id="running-tests">
					<!-- running tests get attached here -->
				</div>
			</div>

		</div>
	</div>

	<script type="text/javascript">
		/**
		 *
		 */
		$(function() {

            FAPI_UI.showBusy('Loading available tests...');

			FAPI_UI.loadHomepageTemplates()
			.then(function() {
				return FAPI_UI.getUserInfo();
			}).then(function() {
			    return loadAvailableTests();
			}).then(function() {
				return loadAvailablePlans();
			}).then(function() {
				return loadLastConfig();
			}).then(function() {
				return loadIndexPage();
			}).then(function(){
				return loadServerInfo();
			});
		});

		function loadAvailableTests() {
			return $.getJSON('/api/runner/available', function(data) {
                // save the list of available tests and associated info for later
                FAPI_UI.availableTests = _.keyBy(data, 'testName');
                //console.log('available: ', JSON.stringify(FAPI_UI.availableTests));

                // sort the tests into groups by profile
                var groupedTests = _.groupBy(data, 'profile');
                // consistent ordering for groups
                var profiles = _.keys(groupedTests).sort();

                // render all of the tests into the dropdown
                _.each(profiles, function(profile) {

                    var optGroup = $(FAPI_UI.logTemplates.TEST_OPTGROUP({
                        label: profile
                    }));
                    $('#testSelect').append(optGroup);

                    // note that we're sorting the tests within each group as well
                    _.each(_.sortBy(groupedTests[profile], 'displayName'), function(item) {
                        optGroup.append(FAPI_UI.logTemplates.TEST_OPTION({
                        	   val: item.testName,
                        	   display: item.displayName
                        }));
                    });

                });
            });
		}

		function loadAvailablePlans() {
			return $.getJSON('/api/plan/available', function(data) {
				FAPI_UI.availablePlans = _.keyBy(data, 'planName');

				// sort the plans into groups by profile
				var groupedPlans = _.groupBy(data, 'profile');
				// consistent ordering for plans
				var profiles = _.keys(groupedPlans).sort();

				// render all the plans into the dropdown
				_.each(profiles, function(profile) {

					var optGroup = $(FAPI_UI.logTemplates.TEST_OPTGROUP({
						label: profile
					}));
					$('#planSelect').append(optGroup);

					// note that we're sorting the plans within each group as well
					_.each(_.sortBy(groupedPlans[profile], 'displayName'), function(item) {
						optGroup.append(FAPI_UI.logTemplates.TEST_OPTION({
							val: item.planName,
							display: item.displayName
						}));
					});
				});

			});
		}

		function saveConfig(config) {
			var localStorage = tryGetStorage('sessionStorage');
			if (localStorage) {
				localStorage.setItem('savedConfig', JSON.stringify(config));
			}
		}

		function clearSavedConfig() {
			var localStorage = tryGetStorage('sessionStorage');
			if (localStorage) {
				localStorage.removeItem('savedConfig');
			}
		}

		function loadLastConfig() {
			var localStorage = tryGetStorage('sessionStorage');
			var localSavedConfig;

			try {
				localSavedConfig = localStorage ? JSON.parse(localStorage.getItem('savedConfig')) : null;
				clearSavedConfig();
			} catch (e) {
				localSavedConfig = null;
			}

			// If we left the page with an unsaved config, restore it now.

			if (localSavedConfig) {
				$('#config').val(localSavedConfig.config);
				if (localSavedConfig.testName) {
					$('#singleTestSelector').prop('checked', true).change();
					$('#testSelect option[value=' + localSavedConfig.testName + ']').prop('selected', true).change();
				} else if (localSavedConfig.planName) {
					$('#singleTestSelector').prop('checked', false).change();
					$('#planSelect option[value=' + localSavedConfig.planName + ']').prop('selected', true).change();
				}
				return true;
			}

			// Otherwise, try to get a config from the server

			return $.getJSON('/api/lastconfig', function(data) {

				if (data.config) {
					// we found a configuration file, load it up

					$("#config").val(JSON.stringify(data.config, null, 4));

					if (data.testName) {
						$('#singleTestSelector').prop('checked', true).change();
						$('#testSelect option[value=' + data.testName + ']').prop('selected', true).change();
					} else if (data.planName) {
						$('#singleTestSelector').prop('checked', false).change();
						$('#planSelect option[value=' + data.planName + ']').prop('selected', true).change();
					}

				} else {

					// otherwise set the defaults

					$("#config").val(JSON.stringify(FAPI_UI.testJSON, null, 4));
				}

			});
		}

		function loadIndexPage() {
			$('#createTestBtn').click(function(evt) {
				var testName = $('#testSelect').val();

				// if the user hasn't picked anything, just bail here
				if (!testName || testName == 'select') {
					//console.log("No test selected");
					FAPI_UI.showError({
						error: "Please select a test from the dropdown list"
					});
					return;
				}

				//console.log('Button clicked: ' + testName);

				/* Figures out which tab is visible then populates the form appropriately
				this is to ensure that the $('#config') value has properly updated in the event of a
				quick paste into a form field  with no tab switch and then a button press */
				if ($("#formInput").hasClass("active")) {
					updateJSONFromFormElements();
				}

				FAPI_UI.showBusy('Creating test...');

				// Stash the config in case we are unable to create the test
				saveConfig({ config: $('#config').val(), testName: testName });

				var createUrl = '/api/runner/?test=' + encodeURIComponent(testName);
				if (hasVariants(testName)) {
					var selectedVariant = $('#variantSelector').val();

					createUrl += '&variant=' + encodeURIComponent(selectedVariant);
				}

				$.ajax({
					url: createUrl,
					type: 'POST',
					contentType: 'application/json',
					data: $('#config').val(),
					success: function(data, status) {
						clearSavedConfig();
						// forward to the test info page
						window.location.assign('/log-detail.html?log=' + encodeURIComponent(data.id));
					},
					error: function(jqxhr, status, error) {
						FAPI_UI.hideBusy();
						FAPI_UI.showError(jqxhr.responseJSON ? jqxhr.responseJSON : {
							code: jqxhr.status,
							error: error
						});
						updateRunningTable();
					}
				});
			});

			$('#createPlanBtn').click(function(evt) {
				var planName = $('#planSelect').val();

				// if the user hasn't picked anything, just bail
				if (!planName || planName == 'select') {
					FAPI_UI.showError({
						error: "Please select a test plan from the dropdown list"
					});
					return;
				}

                /* Figures out which tab is visible then populates the form appropriately
                this is to ensure that the $('#config') value has properly updated in the event of a
                quick paste into a form field  with no tab switch and then a button press */
                if ($("#formInput").hasClass("active")) {
                    updateJSONFromFormElements();
                }

                FAPI_UI.showBusy('Creating plan...');

				// Stash the config in case we are unable to create the test
				saveConfig({ config: $('#config').val(), planName: planName });

				var createUrl = '/api/plan?planName=' + encodeURIComponent(planName);
				if (hasVariants(planName)) {
					var selectedVariant = $('#variantSelector').val();

					createUrl += '&variant=' + encodeURIComponent(selectedVariant);
				}

                $.ajax({
                	   url: createUrl,
                	   type: 'POST',
                	   contentType: 'application/json',
                	   data: $('#config').val(),
                	   success: function(data, status) {
                		   clearSavedConfig();
                		   // forward to the test plan page
                		   window.location.assign('/plan-detail.html?plan=' + encodeURIComponent(data.id));
                	   },
                    error: function(jqxhr, status, error) {
                        FAPI_UI.hideBusy();
                        FAPI_UI.showError(jqxhr.responseJSON ? jqxhr.responseJSON : {
                            code: jqxhr.status,
                            error: error
                        });
                        updateRunningTable();
                    }
                });
			});

			// update field visibility when the selectors change
			$('#testSelect').on('change', function(_) {
				updateVariants();
				updateConfigFieldVisibility();
			});
			$('#planSelect').on('change', function(_) {
				updateVariants();
				updateConfigFieldVisibility();
			});

			// update the config visibility right now
			updateVariants();
			updateConfigFieldVisibility();

			$('#refresh').click(function(event) {
				updateRunningTable();
			});
			// refresh the running table right now
			updateRunningTable();

			// Config UI
			$(".config-form-element").attr("autocomplete", "off");
			$(".config-form-element").attr("autocorrect", "off");
			$(".config-form-element").attr("autocapitalize", "off");
			$(".config-form-element").attr("spellcheck", "false");

			// tab actions
			$('#tab-form-elements').click(function(e) {
				updateFormElementsFromJSON();
			})

			$('#tab-json-elements').click(function(e) {
				updateJSONFromFormElements();
			})

			// sync the JSON at least once
			updateFormElementsFromJSON();

			// update the test/plan components on the toggle switch
			$('#singleTestSelector').on('change', function (_) {
				updateVariants();
				updateSingleTestSelector();
			});
			// refresh right now
			updateSingleTestSelector();

            FAPI_UI.hideBusy();

		}

		function updateSingleTestSelector() {
            if ($('#singleTestSelector').is(':checked')) {
                // single test selected
                $('#testSelector').show();
                $('#planSelector').hide();
                $('#createTestBtn').show();
                $('#createPlanBtn').hide();
            } else {
                // multi test plan selected
                $('#testSelector').hide();
                $('#planSelector').show();
                $('#createTestBtn').hide();
                $('#createPlanBtn').show();
            }
            updateConfigFieldVisibility();
		}

		function hasVariants(name) {
			if ($('#singleTestSelector').is(':checked')) {

				return FAPI_UI.availableTests[name].variants && FAPI_UI.availableTests[name].variants.length > 0;
			} else {

				return FAPI_UI.availablePlans[name].variants && FAPI_UI.availablePlans[name].variants.length > 0;
			}

		}

		function updateConfigFieldVisibility() {

            if ($('#singleTestSelector').is(':checked')) {
            	   // single test selected
				var testName = $('#testSelect').val();

				// if the user hasn't picked anything, disable the create button
				if (!testName || testName == 'select' || !FAPI_UI.availableTests[testName]) {
					//console.log("No test selected");
					var fieldsToShow = [];
					$('#createTestBtn').prop('disabled', true);
				} else {
					var fieldsToShow = FAPI_UI.availableTests[testName].configurationFields;
					// enable the create button
					$('#createTestBtn').prop('disabled', false);
				}

				if (!fieldsToShow) {
					// the test hasn't defined anything, set a default
					fieldsToShow = [];
				}
            } else {
            	   // multi test plan selected
            	   var planName = $('#planSelect').val();

            	   // if the user hasn't picked anything, disable the create button
            	   if (!planName || planName == 'select' || !FAPI_UI.availablePlans[planName]) {
            		   var fieldsToShow = [];
            		   $('#createPlanBtn').prop('disabled', true);
            	   } else {
            		   var fieldsToShow = FAPI_UI.availablePlans[planName].configurationFields;

            		   // add in any fields from the associated modules
        			   _.each(FAPI_UI.availablePlans[planName].moduleNames, function(module) {
                           if (FAPI_UI.availableTests[module]) {
                               fieldsToShow = _.uniqBy(fieldsToShow.concat(FAPI_UI.availableTests[module].configurationFields));
                           }
        			   });

            		   $('#createPlanBtn').prop('disabled', false);
            	   }
            }

			fieldsToShow.push('alias', 'description', 'publish'); // always show the alias, description, and publish fields

			// show/hide all the appropriate fields on the page
			$('.config-form-element-container').each(function() {
				if (_.includes(fieldsToShow, $('.config-form-element', this).data("jsonTarget"))) {
					$(this).show();
				} else {
					$(this).hide();
				}
			});

			// collapse empty sections
			$('.config-form-container').each(function() {
				var hasAtLeastOneDisplayElement = false;
				$(this).children().not('.config-form-container-header').each(function() {
					if ($(this).css("display") !== "none") {
						hasAtLeastOneDisplayElement = true;
						// found at least one visible element, break the loop
						return false;
					}
				});

				if (hasAtLeastOneDisplayElement) {
					$('.config-form-container-header', this).show();
				} else {
					// there are no visible elements anymore, hide the header
					$('.config-form-container-header', this).hide();
				}
			});
		}

		function updateVariants() {
			if ($('#singleTestSelector').is(':checked')) {
				// single test selected
				var map = FAPI_UI.availableTests;
				var itemSelected = $('#testSelect').val();

			} else {
				// multi test selected
				var map = FAPI_UI.availablePlans;
				var itemSelected = $('#planSelect').val();
			}

			$('#variantSelector').find('option').remove();
			if (map[itemSelected] && map[itemSelected].variants && map[itemSelected].variants.length > 0) {

				// update the variant display
				_.each(map[itemSelected].variants, function(variant) {

					$('#variantSelector').append(FAPI_UI.logTemplates.TEST_OPTION({

						val: variant.name,
						display: variant.name
					}));
				});

				$('#variantSelector').show();
			} else {

				// don't show the variant if there's none to show
				$('#variantSelector').hide();
			}
		}

		/**
		 *
		 */
		function updateRunningTable() {
			return $.getJSON('/api/runner/running', function(data) {
				//console.log('running: ', JSON.stringify(data));
				$('#running-tests').html('');

				// run this as a string of deferreds to guarantee order
				var deferred = $.when(1);

				_.each(data, function(testId) {
					//console.log('getting: ' + testId);
					deferred = deferred.then(function() {
						return getRunningTest(testId);
					});
				});

				deferred.then(function() {
					$('[data-toggle="tooltip"]').tooltip({
						container: 'body'
					});
				});
			});

		}

		function getRunningTest(testId) {
			return $.getJSON('/api/runner/' + encodeURIComponent(testId), function(data) {

				var runningTest = $(FAPI_UI.logTemplates.RUNNING_TEST({
					test: data
				}));

				$('#running-tests').append(runningTest);

				$('.downloadBtn', runningTest).click(function(evt) {
					evt.preventDefault();
					window.open('/api/log/' + encodeURIComponent(testId) + '?dl=true');
				});
			}).then(function() {

				var _self =  $(`[data-instance-id='${testId}']`);

				return $.ajax({
                    type: 'GET',
                    url: '/api/info/' + encodeURIComponent(testId),
                    data: {},
                    success: function(data) {
                        $('.testStatusAndResult', _self).html(FAPI_UI.logTemplates.TEST_STATUS({test: data}));
                    },
                    error: function(jqxhr, status, error) {
                        FAPI_UI.showError(jqxhr.responseJSON ? jqxhr.responseJSON : {
                            code: jqxhr.status,
                            error: error
                        });
                    }
                });
			});
		}

		/**
		 *
		 */
		function updateJSONFromFormElements() {
			var children = $("#formInput").find(".config-form-element");

			_.each(children, function(child) {
				populateJSON($(child).data("jsonTarget"), $(child).val());
			});

			$("#config").val(JSON.stringify(FAPI_UI.testJSON, null, 4));
		}

		/**
		 *
		 */
		function updateFormElementsFromJSON() {
			try {
				FAPI_UI.testJSON = JSON.parse($("#config").val());
			} catch (e) {
				FAPI_UI.showError({
					error: e
				});
				return false;
			}

			// valid JSON, but we also want to verify that it is an object at the root node
			if (typeof FAPI_UI.testJSON != 'object') {
				FAPI_UI.showError({
					error: "Please ensure that your root node JSON is an object"
				});
				return false;
			}

			$(".config-form-element").val(""); // clear all form details - we are going to read it in from the JSON

			walkJSON(FAPI_UI.testJSON);
		}

		/**
		 *
		 */
		function walkJSON(element, root) {

			_.each(element, function(value, key, obj) {
				var el = null;

				if (_.isString(value) && root == undefined && key != undefined) {
					el = $(".config-form-element[data-json-target='" + key + "']");
				} else {
					el = $(".config-form-element[data-json-target='" + root + "." + key + "']");
				}

				if (el && $(document).find(el).length) {
					if (_.isArray(value) || _.isObject(value)) {
						el.val(JSON.stringify(value));
					} else {
						el.val(value);
					}
				} else {
					if (_.isObject(value)) {
						if (root != undefined) {
							walkJSON(value, root + "." + key);
						} else {
							walkJSON(value, key);
						}
					}
				}
			});
		}

		/**
		 *
		 */

		function populateJSON(key, val) {
			// check to see if we have an "array string" or a "number string"
			// i.e. something we want to parse as an array/object/number because the val parameter always comes through as a string from the text input
			try {
				var stringToJSON = JSON.parse(val); // an array, object or number ?
				if (_.isArray(stringToJSON) || _.isObject(stringToJSON)) {
					FAPI_UI.prop(FAPI_UI.testJSON, key, stringToJSON);
				} else if (_.isNumber(stringToJSON)) {
					FAPI_UI.prop(FAPI_UI.testJSON, key, val);
				}
			} catch (e) { // a string
				if (val == "") { // if we have an empty string then delete the value
					FAPI_UI.removeFromObject(FAPI_UI.testJSON, key);
				} else {
					FAPI_UI.prop(FAPI_UI.testJSON, key, val);
				}
			}

			//console.log("FAPI_UI.testJSON=" + JSON.stringify(FAPI_UI.testJSON));
		}

		function loadServerInfo() {
			return $.getJSON('/api/server', function(data) {
				$(".serverInfo").text([(data.hasOwnProperty("external_ip") ? "External IP: " + data.external_ip:""), (data.hasOwnProperty("version") ? "Version: " +data.version:"")].filter(Boolean).join(" - "));
			});
		}

		function tryGetStorage(type) {
			// simple check to see whether browser storage is usable
			try {
				var storage = window[type];
				var x = '__storage_test__';
				storage.setItem(x, x);
				storage.removeItem(x);
				return storage;
			} catch (e) {
				return null;
			}
		}
	</script>

	<footer class="pageFooter">
		<span class="muted">OpenID Foundation conformance suite</span>
		<div class="serverInfo"></div>
	</footer>
</body>
</html>
